<template>
    <div>
        <div class="row mt-4">
            <div class="col-12">
                <FileUploader ref="uploader" accepted-file-types="text/plain" :maxFiles="1" :allow-multiple="false"
                    :addImagePreview="false" :addPdfPreview="false" />
            </div>
            <div class="col-12">
                <button type="button" class="btn btn-principal px-2" @click="procesarArchivo()">
                    Leer Archivo
                </button>
            </div>
        </div>
    </div>
</template>

<script setup lang="ts">
//librerias
import { ref, onMounted } from "vue";
import { loading, urlApi } from "@/shared.js";
import { FileUploader } from "@hcd-bsas/vue3-components";
import Swal from "sweetalert2/dist/sweetalert2.js";
import http from "@/http";
import router from "@/router";

const uploader = ref();

async function procesarArchivo() {
    var files = uploader.value.getFiles();
    if (files.length == 0) {
        Swal.fire({
            icon: 'error',
            title: 'Error',
            text: "Agrege Un Archivo Para Procesar.",
        });
        return false;
    }
    var array_LiqCabOP = "";
    var file = files[0].file;
    loading.show();
    var dataText = await file.text();
    var lines = dataText.split('\n');
    lines.forEach((line: string) => {
        let id_liq_cab = line.substring(10, 20);
        let nro_opago = line.substring(140, 145);
        array_LiqCabOP += id_liq_cab + ";" + nro_opago + "|";
    });
    try {
        //hay que validar que el nombre no empiece con ENTE y que ademas , si el array no parseo nada, que tire error . (como validar el array por linea RARO)
        const response = await http.post(urlApi + "subirArchivoSafin", { nombre_archivo: file.name, array_LiqCabOP: array_LiqCabOP });
        if (response.status == 200 && response.data.status == "success") {
            Swal.fire({
                icon: 'success',
                title: 'Exito',
                text: "Archivo procesado con exito",
            });
            router.push({
                name: "inicioArchivoSafin",
            })
        }
    } catch (error) {
        Swal.fire({
            icon: 'error',
            title: 'Error',
            text: "Ha ocurrido un error al procesar el archivo. ",
        });
        uploader.value.removeFile();
        loading.hide();
    }
    uploader.value.removeFile();
    loading.hide();
}

</script>
